com.io7m.r2.core

## Interface R2InstanceBillboardedDynamicType

- All Superinterfaces:
    com.io7m.jcanephora.core.JCGLResourceUsableType, R2DeletableType, R2InstanceBillboardedType, R2InstanceType
  All Known Implementing Classes:
    R2InstanceBillboardedDynamic

      public interface R2InstanceBillboardedDynamicType
      extends R2InstanceBillboardedType, R2DeletableType

  The type of billboarded instances that are expected to change often, both in the number of instances, and the values of individual instances.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `addInstance(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> position, float scale, float rotation)` Enable rendering of an instance with transform `t`
    `void` | `clear()` Clear all instances.
    `int` | `maximumSize()`

    - ### Methods inherited from interface com.io7m.r2.core.R2InstanceBillboardedType

      `arrayObject, enabledCount, update`

    - ### Methods inherited from interface com.io7m.r2.core.R2InstanceType

      `instanceID`

    - ### Methods inherited from interface com.io7m.r2.core.R2DeletableType

      `delete`

    - ### Methods inherited from interface com.io7m.jcanephora.core.JCGLResourceUsableType

      `isDeleted`

- - ### Method Detail

    - #### maximumSize

          int maximumSize()

      Returns:
        The maximum number of instances that can be placed into the set

    - #### clear

          void clear()

      Clear all instances.

    - #### addInstance

          int addInstance(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> position,
                          float scale,
                          float rotation)
                   throws R2ExceptionBatchIsFull

      Enable rendering of an instance with transform `t`
      Parameters:
        `position` - The world-space position
        `scale` - The scale
        `rotation` - The rotation
      Returns:
        The index of the enabled instance
      Throws:
        `R2ExceptionBatchIsFull` - If the batch cannot accept any more instances

Copyright © 2016 <code@io7m.com> http://io7m.com